/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2009-2012 Bull S.A.S.
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

package org.ow2.jonas.admin.osgi.bundle;

import org.apache.felix.ipojo.annotations.Component;
import org.apache.felix.ipojo.annotations.Instantiate;
import org.apache.felix.ipojo.annotations.Invalidate;
import org.apache.felix.ipojo.annotations.Provides;
import org.apache.felix.ipojo.annotations.ServiceProperty;
import org.apache.felix.ipojo.annotations.Validate;
import org.osgi.framework.BundleContext;
import org.ow2.kerneos.core.service.KerneosSimpleService;
import org.ow2.util.log.Log;
import org.ow2.util.log.LogFactory;

@Component
@Instantiate
@Provides
public class osgiBundleService implements KerneosSimpleService {
    @ServiceProperty(name = KerneosSimpleService.ID, value = "bundleService")
    private String id;

    BundleContext bc = null;

    BundleListPlugin blp = null;

    public static Log logger = LogFactory.getLog(osgiBundleService.class);

    public osgiBundleService(BundleContext bctx) {
        this.bc = bctx;
    }

    @Validate
    private void start() {
        logger.debug("");
        blp = new BundleListPlugin(bc);
    }

    @Invalidate
    private void stop() {
        logger.debug("");
    }

    public BundleActionResult install(final String url) {
        return blp.install(url, bc);
    }

    public BundleActionResult action(final String actionType, final String selectedids) {
        //errorService.setError("Test Error");
        return blp.action(actionType, selectedids, bc);
    }

    public BundleInfoResult create() {
        return blp.create(bc);
    }

    public BundleInfoResult update() {
        return blp.update(bc);
    }
}
