/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2009-2012 Bull S.A.S.
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

package org.ow2.jonas.admin.osgi.obr;


import org.apache.felix.ipojo.annotations.Component;
import org.apache.felix.ipojo.annotations.Instantiate;
import org.apache.felix.ipojo.annotations.Invalidate;
import org.apache.felix.ipojo.annotations.Provides;
import org.apache.felix.ipojo.annotations.ServiceProperty;
import org.apache.felix.ipojo.annotations.Validate;
import org.osgi.framework.BundleContext;
import org.ow2.kerneos.core.service.KerneosSimpleService;
import org.ow2.util.log.Log;
import org.ow2.util.log.LogFactory;

@Component
@Instantiate
@Provides
public class osgiOBRService implements KerneosSimpleService {
    @ServiceProperty(name = KerneosSimpleService.ID, value = "obrService")
    private String id;


    BundleContext bc = null;

    OBRPlugin op = null;

    public static Log logger = LogFactory.getLog(osgiOBRService.class);

    public osgiOBRService(BundleContext bctx) {
        this.bc = bctx;
    }

    @Validate
    private void start() {
        logger.debug("");
        op = new OBRPlugin(bc);
    }

    @Invalidate
    private void stop() {
        logger.debug("");
    }

    public String create() {
        return op.create(bc);
    }

    public String add(final String url) {
        return op.add(url, bc);
    }

    public String remove(final String paths) {
        return op.remove(paths, bc);
    }

    public String refresh(final String paths) {
        return op.refresh(paths, bc);
    }

    public String info(final String paths) {
        return op.info(paths, bc);
    }

    public String deploy(final String paths) {
        return op.deploystart(paths, bc, false);
    }

    public String start(final String paths) {
        return op.deploystart(paths, bc, true);
    }
}