/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2009 Bull S.A.S.
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */

package org.ow2.jonas.admin.osgi.service;

import java.util.ArrayList;
import java.util.List;

import org.osgi.framework.Bundle;
import org.osgi.framework.BundleContext;
import org.osgi.framework.Constants;
import org.osgi.framework.InvalidSyntaxException;
import org.osgi.framework.ServiceReference;

public class ServicePlugin {

    public ServicePlugin(final BundleContext bc) {
        // TODO Auto-generated constructor stub
    }

    public List<ServiceInfo> create(final BundleContext bc) {
        // TODO Auto-generated method stub
        List<ServiceInfo> list = new ArrayList<ServiceInfo>();
        try {
            for (ServiceReference sr : bc.getAllServiceReferences(null, null)) {
                ServiceInfo si = new ServiceInfo();
                si.setId(sr.getProperty("service.id").toString());
                si.setName(bc.getService(sr).getClass() + "@" + bc.getService(sr).hashCode());
                list.add(si);
            }
        } catch (InvalidSyntaxException e) {
            e.printStackTrace();
        }
        return list;
    }

    public String select(final String service, final BundleContext bc) {
        // TODO Auto-generated method stub
        String xml = "";
        String name = null;
        try {
            for (ServiceReference sr : bc.getAllServiceReferences(null, null)) {
                if (service.equals(bc.getService(sr).getClass() + "@" + bc.getService(sr).hashCode())) {
                    xml = xml + "ServiceBundle:\n";
                    xml = xml + "\t\tid:" + sr.getBundle().getBundleId();
                    name = (String) sr.getBundle().getHeaders().get(Constants.BUNDLE_NAME);
                    name = (name == null) ? sr.getBundle().getLocation() : name;
                    xml = xml + "\t\t" + name + "\n";
                    xml = xml + "UsingBundles:\n";
                    if (sr.getUsingBundles() != null) {
                        for (Bundle b : sr.getUsingBundles()) {
                            name = (String) b.getHeaders().get(Constants.BUNDLE_NAME);
                            name = (name == null) ? b.getLocation() : name;
                            xml = xml + "\t\tid:" + b.getBundleId();
                            xml = xml + "\t\t" + name + "\n";
                        }
                    }
                    xml = xml + "\n";
                    if (sr.getPropertyKeys() != null && sr.getPropertyKeys().length != 0) {
                        xml = xml + "Properties:\n";
                        for (String key : sr.getPropertyKeys()) {
                            String value = sr.getProperty(key).toString();
                            xml = xml + "\t\tname:\t" + key;
                            xml = xml + "\n\t\tvalue:\t" + value + "\n\n";
                        }
                    }
                }
            }
        } catch (InvalidSyntaxException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return xml;
    }

}
